/*
8x8LEDģ飬MAX7219
Flash moving ...
A website may be useful as https://xantorohara.github.io/led-matrix-editor/
Board: STC8H8K64U
Author: Jin-Lei Li
Email: lijinlei0907@163.com
Date: Mar. 18, 2024
*/

#include <STC8H.H>
#include <intrins.h>

#define MAIN_Fosc 35000000UL		//Ƶ35MHz

typedef unsigned char u8;
typedef unsigned int u16;
typedef unsigned long int u32;

/*-------------- Define MAX7219 IO ----------------*/
sbit Max7219_pinCLK = P2^2;
sbit Max7219_pinCS  = P2^1;
sbit Max7219_pinDIN = P2^0;

void Delay_xms(u16 ms);
void Init_MAX7219(void);
void Write_Max7219(u8 address,u8 dat);
void Write_Max7219_byte(u8 DATA);

u8 code disp1[2][8]={
0x18,0x30,0x78,0x70,0x38,0x28,0x6C,0x00,//flash_0
0x06,0x0C,0x1E,0x1E,0x18,0x24,0x44,0x00,//flash_1
};

/*-------------- Main Program ----------------------*/
void main(void)
{
	u8 i,j;
	u8 row = 2;
	//EAXFR = 1;				//ʹXFR
	//CKCON = 0x00;			//ⲿٶ
	//WTST = 0x00;			//óȡȴʱΪ0ʱӣCPUִгٶ
	
	P0M1 = 0x00;P0M0 = 0x00;		//P0Ϊ׼˫ģʽ 00׼˫ 01 10 11©
	P1M1 = 0x00;P1M0 = 0x00;		//P1Ϊ׼˫ģʽ 00׼˫ 01 10 11©
	P2M1 = 0x00;P2M0 = 0x00;		//P2Ϊ׼˫ģʽ 00׼˫ 01 10 11©
	
	Delay_xms(50);
	Init_MAX7219();  
	while(1)
	{
		for(j=0;j<row;j++)
		{
			for(i=1;i<9;i++)
				Write_Max7219(i,disp1[j][i-1]);
			Delay_xms(500);
		}  
	} 
}
/*-------------------------------------------
ܣMAX7219д
ڲaddressdat
ڲ
---------------------------------------------*/
void Write_Max7219(u8 address,u8 dat)
{
	Max7219_pinCS = 0;
	Write_Max7219_byte(address);           //дַܱ
  Write_Max7219_byte(dat);               //дݣʾ 
	Max7219_pinCS = 1;                        
}

void Init_MAX7219(void)
{
	Write_Max7219(0x09, 0x00);       //뷽ʽBCD
	Write_Max7219(0x0a, 0x03);       // 
	Write_Max7219(0x0b, 0x07);       //ɨޣ8ʾ
	Write_Max7219(0x0c, 0x01);       //ģʽ0ͨģʽ1
	Write_Max7219(0x0f, 0x00);       //ʾԣ1Խʾ0
}
/*--------------------------------------------
ܣMAX7219(U3)дֽ
ڲDATA 
ڲ
---------------------------------------------*/
void Write_Max7219_byte(u8 DATA)
{
	u8 i;    
	Max7219_pinCS=0;		
	for(i=8;i>=1;i--)
  {
		Max7219_pinCLK = 0;
    Max7219_pinDIN = DATA&0x80;
    DATA = DATA << 1;
    Max7219_pinCLK = 1;
  }                                 
}
/*-------------- Time Delay -----------------*/
void Delay_xms(u16 ms)
{
	u16 i;
	do
	{
		i = MAIN_Fosc / 10000;
		while(--i);
	}
	while(--ms);
}